/////////////////////////////////////////////////////////////////////////
// IceMenuCompiler.h - headerfile for IceMenuScanner and IceMenuInParser
// created:       mig 000720
// modified:      mig 001001
/////////////////////////////////////////////////////////////////////////

#ifndef ICEMENUINCOMPILER_H
#define ICEMENUINCOMPILER_H

#include "IceMC.h"

class IceMenuScanner {
public:
  IceMenuScanner();
  IceMenuScanner(const QString filePath);
  ~IceMenuScanner();
  /* data */
  enum symbolCode { noSy, eolSy, eofSy, quoteSy, lBraceSy, rBraceSy,
		    menuSy, progSy, restartSy, separatorSy, identSy, quotedIdentSy};
  /* methods */
  void setFile(const QString filePath);
  symbolCode newSy();
  QString getIdentStr() const;
  void getActPos(int& line, int& sy);
private:
  /* data */
  symbolCode sy;
  QString identStr;
  QString srcLine;
  uint synr;
  int lnr;
  QChar ch;
  QFile* src;
  QTextStream* srcStream;
  /* methods */
  QChar newChar();
};

class IceMenuInParser {
public:
  IceMenuInParser();
  ~IceMenuInParser();
  void parseFile(IceListView* menuList, const QString filePath);
  void errorPos(int& lineNr, int& charNr);
  bool successful();
private:
  bool success;
  IceMenuScanner::symbolCode sy;
  int errlnr;
  int errcnr;
  IceMenuScanner* scanner;
  void s(IceListView* menuList);
  void entry(IceListView* menuList, IceListViewItem* subList);
  void menu(IceListViewItem* e);
  void prog(IceListViewItem* e); // also handles restart
  QString name();
  QString icon();
  QString exec();
  void identifier(QString& identStr);
  void syntaxError();  
  void semError(QString errorMsg);
};

#endif







